module Simplepub
  module Cli
    class Config < Thor
      include Thor::Actions

      desc "install", "Install configuration file"
      def install
        if Process.uid == 0
          install_as_root
        else
          install_as_user
        end
      end

      def self.source_root
        Simplepub.templates_root
      end

      private

      def install_as_root
        say "Installing system wide as root", :green
        directory "/etc/simplepub"
        template "simplepub.yml", "/etc/simplepub/config.yml"
      end

      def install_as_user
        say "Installing locally", :green
        template "simplepub.yml", "#{ENV['HOME']}/.simplepub.yml"
      end
    end
  end
end
