require "simplepub/view_helpers"

module Simplepub
  class Engine < Rails::Engine
    # Loads the simplepub.yml file if it exists.
    initializer "simplepub.config" do
      path = Rails.root.join("config/simplepub.yml")
      Simplepub.load_config(path, Rails.env) if path.exist?
    end

    # Adds the ViewHelpers into ActionView::Base
    initializer "simplepub.view_helpers" do
      ActionView::Base.send :include, ViewHelpers
    end
  end
end
